local ids_func = Idstring
local table_contains = table.contains
local has_prettierfbi = SystemFS:exists("assets/mod_overrides/Prettier FBI Units")
local has_elitefbis = SystemFS:exists("assets/mod_overrides/FBI Elites Replace GenSec")

local big_idstring_table = {
	ids_func("units/payday2/characters/ene_tazer_1/ene_tazer_1"),
	ids_func("units/payday2/characters/ene_tazer_1/ene_tazer_1_husk"), 		
	ids_func("units/pd2_dlc_gitgud/characters/ene_zeal_tazer/ene_zeal_tazer"), 
	ids_func("units/pd2_dlc_gitgud/characters/ene_zeal_tazer/ene_zeal_tazer_husk"), 
	ids_func("units/pd2_dlc_hvh/characters/ene_tazer_hvh_1/ene_tazer_hvh_1"), 
	ids_func("units/pd2_dlc_hvh/characters/ene_tazer_hvh_1/ene_tazer_hvh_1_husk"), 
	ids_func("units/pd2_dlc_bph/characters/ene_murkywater_tazer/ene_murkywater_tazer"), 
	ids_func("units/pd2_dlc_bph/characters/ene_murkywater_tazer/ene_murkywater_tazer_husk"), 
	ids_func("units/pd2_dlc_bex/characters/ene_swat_tazer_policia_federale/ene_swat_tazer_policia_federale"), 
	ids_func("units/pd2_dlc_bex/characters/ene_swat_tazer_policia_federale/ene_swat_tazer_policia_federale_husk"), 
	ids_func("units/pd2_dlc_hvh/characters/ene_shield_hvh_2/ene_shield_hvh_2"), 
	ids_func("units/pd2_dlc_hvh/characters/ene_shield_hvh_2/ene_shield_hvh_2_husk"), 
	ids_func("units/pd2_dlc_hvh/characters/ene_swat_heavy_hvh_1/ene_swat_heavy_hvh_1"), 
	ids_func("units/pd2_dlc_hvh/characters/ene_swat_heavy_hvh_1/ene_swat_heavy_hvh_1_husk"), 
	ids_func("units/pd2_dlc_hvh/characters/ene_swat_heavy_hvh_r870/ene_swat_heavy_hvh_r870"), 
	ids_func("units/pd2_dlc_hvh/characters/ene_swat_heavy_hvh_r870/ene_swat_heavy_hvh_r870_husk"), 
	ids_func("units/payday2/characters/ene_shield_2/ene_shield_2"),
	ids_func("units/payday2/characters/ene_shield_2/ene_shield_2_husk"), 
	ids_func("units/payday2/characters/ene_swat_heavy_1/ene_swat_heavy_1"),
	ids_func("units/payday2/characters/ene_swat_heavy_1/ene_swat_heavy_1_husk"),
	ids_func("units/payday2/characters/ene_swat_heavy_r870/ene_swat_heavy_r870"),
	ids_func("units/payday2/characters/ene_swat_heavy_r870/ene_swat_heavy_r870_husk"),
}	
	
if has_prettierfbi then	
	table.insert(big_idstring_table, Idstring("units/payday2/characters/ene_fbi_heavy_1/ene_fbi_heavy_1"))	
	table.insert(big_idstring_table, Idstring("units/payday2/characters/ene_fbi_heavy_1/ene_fbi_heavy_1_husk"))	
	table.insert(big_idstring_table, Idstring("units/payday2/characters/ene_fbi_heavy_r870/ene_fbi_heavy_r870"))	
	table.insert(big_idstring_table, Idstring("units/payday2/characters/ene_fbi_heavy_r870/ene_fbi_heavy_r870_husk"))	
end
	
if has_elitefbis then	
	table.insert(big_idstring_table, Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36"))	
	table.insert(big_idstring_table, Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36_husk"))	
	table.insert(big_idstring_table, Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870"))	
	table.insert(big_idstring_table, Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870_husk"))	
end

Hooks:PreHook( CopDamage, "_spawn_head_gadget", "smash_generics", function(self, params)
	if not self._head_gear then
		return
	end

	local my_unit = self._unit

	if not table_contains(big_idstring_table, my_unit:name()) then
		return
	end
	
	local head_obj = ids_func("Head")
	local head_object_get = my_unit:get_object(head_obj)
	
	if not head_object_get then
		return
	end
	
	local world_g = World		
	local sound_ext = my_unit:sound()	
	
	world_g:effect_manager():spawn({
		effect = ids_func("effects/particles/bullet_hit/glass_breakable/bullet_hit_glass_breakable"),
		parent = head_object_get		
	})			
	
	sound_ext:play("swat_heavy_visor_shatter", nil, nil)
	sound_ext:play("swat_heavy_visor_shatter", nil, nil)
	sound_ext:play("swat_heavy_visor_shatter", nil, nil)
end)
